## org.apache.lucene.index
Class SegmentReader

    java.lang.Object
      org.apache.lucene.index.IndexReader
          org.apache.lucene.index.SegmentReader

All Implemented Interfaces:
  java.lang.Cloneable

    public class SegmentReader

extends IndexReader
implements java.lang.Cloneable

NOTE: This API is new and still experimental (subject to change suddenly in the next release)

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader
`IndexReader.FieldOption`

Field Summary
`protected boolean` `readOnly`

Fields inherited from class org.apache.lucene.index.IndexReader
`hasChanges`

Constructor Summary
`SegmentReader()`

Method Summary
`java.lang.Object` `clone()` Efficiently clones the IndexReader (sharing most internal state).
`IndexReader` `clone(boolean openReadOnly)` Clones the IndexReader and optionally changes readOnly.
`protected BitVector` `cloneDeletedDocs(BitVector bv)` Clones the deleteDocs BitVector.
`protected byte[]` `cloneNormBytes(byte[] bytes)` Clones the norm bytes.
`Directory` `directory()` Returns the directory this index resides in.
`int` `docFreq(Term t)` Returns the number of documents containing the term `t`.
`protected void` `doClose()` Implements close.
`protected void` `doCommit()` Deprecated.
`protected void` `doCommit(java.util.Map commitUserData)` Implements commit.
`Document` `document(int n, FieldSelector fieldSelector)` Get the `Document` at the `n` th position.
`protected void` `doDelete(int docNum)` Implements deletion of the document numbered `docNum`.
`protected void` `doSetNorm(int doc, java.lang.String field, byte value)` Implements setNorm in subclass.
`protected void` `doUndeleteAll()` Implements actual undeleteAll() in subclass.
`static SegmentReader` `get(boolean readOnly, Directory dir, SegmentInfo si, int readBufferSize, boolean doOpenStores, int termInfosIndexDivisor)`
`static SegmentReader` `get(boolean readOnly, SegmentInfo si, int termInfosIndexDivisor)`
`static SegmentReader` `get(SegmentInfo si)` Deprecated.
`java.lang.Object` `getDeletesCacheKey()` Expert.
`java.lang.Object` `getFieldCacheKey()` Expert
`java.util.Collection` `getFieldNames(IndexReader.FieldOption fieldOption)` Get a list of unique field names that exist in this index and have the specified field option information.
`protected byte[]` `getNorms(java.lang.String field)`
`java.lang.String` `getSegmentName()` Return the name of the segment this reader is reading.
`TermFreqVector` `getTermFreqVector(int docNumber, java.lang.String field)` Return a term frequency vector for the specified document and field.
`void` `getTermFreqVector(int docNumber, java.lang.String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
`void` `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
`TermFreqVector[]` `getTermFreqVectors(int docNumber)` Return an array of term frequency vectors for the specified document.
`int` `getTermInfosIndexDivisor()` For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.
`long` `getUniqueTermCount()` Returns the number of unique terms (across all fields) in this reader.
`boolean` `hasDeletions()` Returns true if any documents have been deleted
`boolean` `hasNorms(java.lang.String field)` Returns true if there are norms stored for this field.
`boolean` `isDeleted(int n)` Returns true if document n has been deleted
`int` `maxDoc()` Returns one greater than the largest possible document number.
`byte[]` `norms(java.lang.String field)` Returns the byte-encoded normalization factor for the named field of every document.
`void` `norms(java.lang.String field, byte[] bytes, int offset)` Read norms into a pre-allocated array.
`int` `numDocs()` Returns the number of documents in this index.
`TermDocs` `termDocs()` Returns an unpositioned `TermDocs` enumerator.
`TermDocs` `termDocs(Term term)` Returns an enumeration of all the documents which contain `term`.
`TermPositions` `termPositions()` Returns an unpositioned `TermPositions` enumerator.
`TermEnum` `terms()` Returns an enumeration of all the terms in the index.
`TermEnum` `terms(Term t)` Returns an enumeration of all terms starting at a given term.

Methods inherited from class org.apache.lucene.index.IndexReader

`acquireWriteLock, close, commit, commit, decRef, deleteDocument, deleteDocuments, document, ensureOpen, flush, flush, getCommitUserData, getCommitUserData, getCurrentVersion, getCurrentVersion, getCurrentVersion, getDisableFakeNorms, getIndexCommit, getRefCount, getSequentialSubReaders, getVersion, incRef, indexExists, indexExists, indexExists, isCurrent, isLocked, isLocked, isOptimized, lastModified, lastModified, lastModified, listCommits, main, numDeletedDocs, open, open, open, open, open, open, open, open, open, open, open, open, open, open, reopen, reopen, reopen, setDisableFakeNorms, setNorm, setNorm, setTermInfosIndexDivisor, termPositions, undeleteAll, unlock`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### readOnly

    protected boolean readOnly

Constructor Detail

### SegmentReader

    public SegmentReader()

Method Detail

### get

    public static SegmentReader get(SegmentInfo si)
                             throws CorruptIndexException,
                                    java.io.IOException

  Deprecated.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### get

    public static SegmentReader get(boolean readOnly,
                                    SegmentInfo si,
                                    int termInfosIndexDivisor)
                             throws CorruptIndexException,
                                    java.io.IOException

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### get

    public static SegmentReader get(boolean readOnly,
                                    Directory dir,
                                    SegmentInfo si,
                                    int readBufferSize,
                                    boolean doOpenStores,
                                    int termInfosIndexDivisor)
                             throws CorruptIndexException,
                                    java.io.IOException

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### cloneNormBytes

    protected byte[] cloneNormBytes(byte[] bytes)

  Clones the norm bytes. May be overridden by subclasses. New and experimental.

  Parameters:
    `bytes` - Byte array to clone
  Returns:
    New BitVector

### cloneDeletedDocs

    protected BitVector cloneDeletedDocs(BitVector bv)

  Clones the deleteDocs BitVector. May be overridden by subclasses. New and experimental.

  Parameters:
    `bv` - BitVector to clone
  Returns:
    New BitVector

### clone

    public final java.lang.Object clone()

  Description copied from class: `IndexReader`
  Efficiently clones the IndexReader (sharing most internal state).

  On cloning a reader with pending changes (deletions, norms), the original reader transfers its write lock to the cloned reader. This means only the cloned reader may make further changes to the index, and commit the changes to the index on close, but the old reader still reflects all changes made up until it was cloned.

  Like `IndexReader.reopen()`, it's safe to make changes to either the original or the cloned reader: all shared mutable state obeys "copy on write" semantics to ensure the changes are not seen by other readers.

  Overrides:
    `clone` in class `IndexReader`

### clone

    public final IndexReader clone(boolean openReadOnly)
                            throws CorruptIndexException,
                                   java.io.IOException

  Description copied from class: `IndexReader`
  Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writeable reader.

  Overrides:
    `clone` in class `IndexReader`
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error

### doCommit

    protected void doCommit()
                     throws java.io.IOException

  Deprecated.

  Description copied from class: `IndexReader`
  Implements commit.

  Specified by:
    `doCommit` in class `IndexReader`
  Throws:
    `java.io.IOException`

### doCommit

    protected void doCommit(java.util.Map commitUserData)
                     throws java.io.IOException

  Description copied from class: `IndexReader`
  Implements commit. NOTE: subclasses should override this. In 3.0 this will become an abstract method.

  Throws:
    `java.io.IOException`

### doClose

    protected void doClose()
                    throws java.io.IOException

  Description copied from class: `IndexReader`
  Implements close.

  Specified by:
    `doClose` in class `IndexReader`
  Throws:
    `java.io.IOException`

### hasDeletions

    public boolean hasDeletions()

  Description copied from class: `IndexReader`
  Returns true if any documents have been deleted

  Specified by:
    `hasDeletions` in class `IndexReader`

### doDelete

    protected void doDelete(int docNum)

  Description copied from class: `IndexReader`
  Implements deletion of the document numbered `docNum`. Applications should call `IndexReader.deleteDocument(int)` or `IndexReader.deleteDocuments(Term)`.

  Specified by:
    `doDelete` in class `IndexReader`

### doUndeleteAll

    protected void doUndeleteAll()

  Description copied from class: `IndexReader`
  Implements actual undeleteAll() in subclass.

  Specified by:
    `doUndeleteAll` in class `IndexReader`

### terms

    public TermEnum terms()

  Description copied from class: `IndexReader`
  Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.

  Specified by:
    `terms` in class `IndexReader`

### terms

    public TermEnum terms(Term t)
                   throws java.io.IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.

  Specified by:
    `terms` in class `IndexReader`
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### document

    public Document document(int n,
                             FieldSelector fieldSelector)
                      throws CorruptIndexException,
                             java.io.IOException

  Description copied from class: `IndexReader`
  Get the `Document` at the `n` th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call `IndexReader.isDeleted(int)` with the requested document ID to verify the document is not deleted.

  Specified by:
    `document` in class `IndexReader`
  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `java.io.IOException` - if there is a low-level IO error
  See Also:
    `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### isDeleted

    public boolean isDeleted(int n)

  Description copied from class: `IndexReader`
  Returns true if document n has been deleted

  Specified by:
    `isDeleted` in class `IndexReader`

### termDocs

    public TermDocs termDocs(Term term)
                      throws java.io.IOException

  Description copied from class: `IndexReader`
  Returns an enumeration of all the documents which contain `term`. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. Thus, this method implements the mapping:

  Term => <docNum, freq>*

  The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

  Overrides:
    `termDocs` in class `IndexReader`
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs()
                      throws java.io.IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermDocs` enumerator.

  Specified by:
    `termDocs` in class `IndexReader`
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### termPositions

    public TermPositions termPositions()
                                throws java.io.IOException

  Description copied from class: `IndexReader`
  Returns an unpositioned `TermPositions` enumerator.

  Specified by:
    `termPositions` in class `IndexReader`
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### docFreq

    public int docFreq(Term t)
                throws java.io.IOException

  Description copied from class: `IndexReader`
  Returns the number of documents containing the term `t`.

  Specified by:
    `docFreq` in class `IndexReader`
  Throws:
    `java.io.IOException` - if there is a low-level IO error

### numDocs

    public int numDocs()

  Description copied from class: `IndexReader`
  Returns the number of documents in this index.

  Specified by:
    `numDocs` in class `IndexReader`

### maxDoc

    public int maxDoc()

  Description copied from class: `IndexReader`
  Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

  Specified by:
    `maxDoc` in class `IndexReader`

### getFieldNames

    public java.util.Collection getFieldNames(IndexReader.FieldOption fieldOption)

  Description copied from class: `IndexReader`
  Get a list of unique field names that exist in this index and have the specified field option information.

  Specified by:
    `getFieldNames` in class `IndexReader`
  Parameters:
    `fieldOption` - specifies which field option should be available for the returned fields
  Returns:
    Collection of Strings indicating the names of the fields.
  See Also:
    `IndexReader.getFieldNames(org.apache.lucene.index.IndexReader.FieldOption)`

### hasNorms

    public boolean hasNorms(java.lang.String field)

  Description copied from class: `IndexReader`
  Returns true if there are norms stored for this field.

  Overrides:
    `hasNorms` in class `IndexReader`

### getNorms

    protected byte[] getNorms(java.lang.String field)
                       throws java.io.IOException

  Throws:
    `java.io.IOException`

### norms

    public byte[] norms(java.lang.String field)
                 throws java.io.IOException

  Description copied from class: `IndexReader`
  Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `java.io.IOException`
  See Also:
    `AbstractField.setBoost(float)`

### doSetNorm

    protected void doSetNorm(int doc,
                             java.lang.String field,
                             byte value)
                      throws java.io.IOException

  Description copied from class: `IndexReader`
  Implements setNorm in subclass.

  Specified by:
    `doSetNorm` in class `IndexReader`
  Throws:
    `java.io.IOException`

### norms

    public void norms(java.lang.String field,
                      byte[] bytes,
                      int offset)
               throws java.io.IOException

  Read norms into a pre-allocated array.

  Specified by:
    `norms` in class `IndexReader`
  Throws:
    `java.io.IOException`
  See Also:
    `AbstractField.setBoost(float)`

### getTermFreqVector

    public TermFreqVector getTermFreqVector(int docNumber,
                                            java.lang.String field)
                                     throws java.io.IOException

  Return a term frequency vector for the specified document and field. The vector returned contains term numbers and frequencies for all terms in the specified field of this document, if the field had storeTermVector flag set. If the flag was not set, the method returns null.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - document for which the term frequency vector is returned
    `field` - field for which the term frequency vector is returned.
  Returns:
    term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
  Throws:
    `java.io.IOException`
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  java.lang.String field,
                                  TermVectorMapper mapper)
                           throws java.io.IOException

  Description copied from class: `IndexReader`
  Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `field` - The name of the field to load
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `java.io.IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getTermFreqVector

    public void getTermFreqVector(int docNumber,
                                  TermVectorMapper mapper)
                           throws java.io.IOException

  Description copied from class: `IndexReader`
  Map all the term vectors for all fields in a Document

  Specified by:
    `getTermFreqVector` in class `IndexReader`
  Parameters:
    `docNumber` - The number of the document to load the vector for
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `java.io.IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getTermFreqVectors

    public TermFreqVector[] getTermFreqVectors(int docNumber)
                                        throws java.io.IOException

  Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector vector contains term numbers and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null.

  Specified by:
    `getTermFreqVectors` in class `IndexReader`
  Parameters:
    `docNumber` - document for which term frequency vectors are returned
  Returns:
    array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
  Throws:
    `java.io.IOException`
  See Also:
    `Field.TermVector`

### getSegmentName

    public java.lang.String getSegmentName()

  Return the name of the segment this reader is reading.

### directory

    public Directory directory()

  Returns the directory this index resides in.

  Overrides:
    `directory` in class `IndexReader`

### getFieldCacheKey

    public final java.lang.Object getFieldCacheKey()

  Description copied from class: `IndexReader`
  Expert

  Overrides:
    `getFieldCacheKey` in class `IndexReader`

### getDeletesCacheKey

    public java.lang.Object getDeletesCacheKey()

  Description copied from class: `IndexReader`
  Expert. Warning: this returns null if the reader has no deletions

  Overrides:
    `getDeletesCacheKey` in class `IndexReader`

### getUniqueTermCount

    public long getUniqueTermCount()

  Description copied from class: `IndexReader`
  Returns the number of unique terms (across all fields) in this reader. This method returns long, even though internally Lucene cannot handle more than 2^31 unique terms, for a possible future when this limitation is removed.

  Overrides:
    `getUniqueTermCount` in class `IndexReader`

### getTermInfosIndexDivisor

    public int getTermInfosIndexDivisor()

  Description copied from class: `IndexReader`

  For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.

  Overrides:
    `getTermInfosIndexDivisor` in class `IndexReader`

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.